﻿DeclareModule EditTranslations
  
 Declare Open() 
  
EndDeclareModule

Module EditTranslations
  
Global winTranslate

;Gadget Variables
Global frmLanguage, txtBaseLanguage, cmbTargetLanguage, strPhrase1, strPhrase2
Global btnFirst, btnPrevious,btnNext,btnLast,btnSave,btnDone

Global TotalPhrases.i, CurrentPhrase.i = 1

;Control Variables
Structure Phrase
  Code.s
  Text.s
EndStructure
Global NewList Phrases.Phrase()  
Global SecondLanguage.s
Global DBID.i, CurrentElement.i

Enumeration FormMenu
  #mnuNew
EndEnumeration

Structure Language
  Title.s
  Code.s
EndStructure
Global Dim Available.Language(0)

Procedure ShowFormTexts()
  
  ;Window Title
  SetWindowTitle(winTranslate,Locale::TranslatedString(85))
   

SetGadgetText(frmLanguage,Locale::TranslatedString(86))
SetGadgetText(btnSave, Locale::TranslatedString(8))
SetGadgetText(btnDone, Locale::TranslatedString(96))
  
EndProcedure

Procedure LoadLanguageCombo()
  
  Define iLoop.i
  
  For iLoop = 0 To ArraySize(Locale::Available()) - 1
    If Locale::Available(iLoop) <> Locale::AppLanguage   
      AddGadgetItem(cmbTargetLanguage,-1,Locale::Available(iLoop))
    EndIf
  Next iLoop
  SetGadgetState(cmbTargetLanguage,0)
  
EndProcedure

Procedure OpenLocalDatabase()
  
  Define GetTotal.s
  Define TotalRows.i

  DBID = OpenDatabase(#PB_Any,Main::ProjectFolder + "Resources" + App::#Pathsep + Main::ProjectTitle +".Lng","","")   

  GetTotal = "Select Count(*) FROM Phrases;" 
 
  DatabaseQuery(DBID, GetTotal.s)
  FirstDatabaseRow(DBID)
  TotalPhrases = Val(GetDatabaseString(DBID,0)) ;Store this in the TotalRows variable
  FinishDatabaseQuery(DBID)                    ;free the query
  
EndProcedure

Procedure ShowPhrase()
  
  Define Criteria.s,SearchLanguage.s
  
  ;Show Base Language Phrase
  SearchLanguage = "LT_" + Locale::AppLanguage
  Criteria = "SELECT " + SearchLanguage + " FROM Phrases LIMIT 1 OFFSET " + Str(CurrentPhrase) + ";"
  DatabaseQuery(DBID, Criteria)
  FirstDatabaseRow(DBID) 
  SetGadgetText(strPhrase1,GetDatabaseString(DBID,0))
  
  ;Show Target Language Phrase
  SearchLanguage = "LT_" + GetGadgetText(cmbTargetLanguage)
  Criteria = "SELECT " + SearchLanguage + " FROM Phrases LIMIT 1 OFFSET " + Str(CurrentPhrase) + ";"
  DatabaseQuery(DBID, Criteria)
  FirstDatabaseRow(DBID) 
  SetGadgetText(strPhrase2,GetDatabaseString(DBID,0))
  
EndProcedure

Procedure SavePhrase()
  
  Define Criteria.s,SearchLanguage.s,Phrase.s
  
  SearchLanguage = "LT_" + GetGadgetText(cmbTargetLanguage)
  Phrase = ReplaceString(GetGadgetText(strPhrase2),"'","''")
  
  Criteria = "UPDATE Phrases SET " + SearchLanguage 
  Criteria = Criteria + " = '" + Phrase
  Criteria = Criteria + "' WHERE " + "LT_" + Locale::AppLanguage + " = '"  + GetGadgetText(strPhrase1) + "';"

  DatabaseUpdate(DBID,Criteria)
  
EndProcedure

Procedure Open()
  
  Define Quit.i = #False  
  
winTranslate = OpenWindow(#PB_Any, 0, 0, 640, 140,"", #PB_Window_SystemMenu)
frmLanguage = FrameGadget(#PB_Any, 10, 10, 620, 50, "")
txtBaseLanguage = TextGadget(#PB_Any, 25, 30, 150, 20, "")
cmbTargetLanguage = ComboBoxGadget(#PB_Any, 330, 30, 150, 20)
strPhrase1 = StringGadget(#PB_Any, 10, 70, 300, 20, "")
strPhrase2 = StringGadget(#PB_Any, 330, 70, 300, 20, "")
btnFirst = ButtonGadget(#PB_Any, 10, 100, 25, 25, "|<")
btnPrevious = ButtonGadget(#PB_Any, 40, 100, 25, 25, "<")
btnNext = ButtonGadget(#PB_Any, 250, 100, 25, 25, ">")
btnLast = ButtonGadget(#PB_Any, 280, 100, 25, 25, ">|")
btnSave = ButtonGadget(#PB_Any, 470, 100, 70, 25, "")
btnDone = ButtonGadget(#PB_Any, 560, 100, 70, 25, "")

ShowFormTexts()

;Show The Base Language
SetGadgetText(txtBaseLanguage,Locale::AppLanguage)

;Load Othe Languages
LoadLanguageCombo()

OpenLocalDatabase()

CurrentPhrase = 0
ShowPhrase()

Repeat
  Event = WaitWindowEvent()

  Select event
    Case #PB_Event_CloseWindow
      
      CloseWindow(winTranslate)
      Break
      
    Case #PB_Event_Menu
      Select EventMenu()
        Case #mnuNew
      EndSelect

    Case #PB_Event_Gadget
      Select EventGadget()
          
        Case cmbTargetLanguage
          
          ShowPhrase()
          Debug "Lang"
          ;SecondLanguage =  "Language Files\" + Available(GetGadgetItemData(cmbLanguage,GetGadgetState(cmbLanguage)))\Code + ".lng"   
          ;SetGadgetText(txtSecond,Available(GetGadgetItemData(cmbLanguage,GetGadgetState(cmbLanguage)))\Title)
          ;If GetGadgetText(String_0) > ""
          ;  ShowPhrase()
          ;EndIf
                    
        Case btnFirst
          
          CurrentPhrase = 0
          ShowPhrase()  

        Case btnPrevious
          
          If CurrentPhrase > 0
            CurrentPhrase = CurrentPhrase - 1
            ShowPhrase()
          EndIf
          
        Case btnNext
          
          If CurrentPhrase < TotalPhrases - 1
            CurrentPhrase = CurrentPhrase + 1
            ShowPhrase()
          EndIf
          
       Case btnLast
         
          CurrentPhrase = TotalPhrases - 1
          ShowPhrase()
                  
        Case btnSave
          
          SavePhrase()
          
        Case btnDone
          Quit = #True
          CloseWindow(winTranslate)
          
      EndSelect
  EndSelect
  
Until Quit = #True
EndProcedure

EndModule
; IDE Options = PureBasic 5.50 (Windows - x64)
; CursorPosition = 158
; FirstLine = 126
; Folding = n-
; EnableXP
; EnableUnicode