﻿UseSQLiteDatabase()
UsePNGImageDecoder()

IncludeFile "App.pbi"


APP::ReadPreferences("LT.ini")

IncludeFile "Locale.pbi"
IncludeFile "dlghelpviewer.pbi"

;Select Language For This Programme If Not set
If App::Language = ""
  Locale::AppLanguage = "English" ;Default
  Locale::Initialise()
  Locale::SelectLanguage()
  App::Language = Locale::AppLanguage
  App::Writepreferences("LT.ini")  
Else
  Locale::AppLanguage = App::Language
EndIf
Locale::Initialise()

DeclareModule Main
  
  Global ProjectFolder.s,ProjectTitle.s,BackupFolder.s
  
EndDeclareModule

Module Main
EndModule

;Modules That rely On Module Main

IncludeFile "EditTranslate.pbi"

Global WinMain,Helpdlg.i,mnuMain.i

;Main Programme Start
Enumeration FormGadget
  #mnuPreferences
  #mnuShowHelp
  #mnuAbout
  #txtProject
  #strProject
  #btnProject
  #txtLanguage 
  #cmbLanguage
  #btnLanguage
  #txtProjectFiles 
  #lstProjectFiles
  #btnScanFile
  #btnScanAll  
  #txtScannedFiles  
  #lstScannedFiles
  #btnUpdateFile
  #btnUpdateAll  
  #txtUpdatedFiles
  #lstUpdatedFiles
  #btnFinish
  #btnEditLanguage
EndEnumeration

Macro FileExists(filename)
  Bool(FileSize(fileName) > -1)
EndMacro

Procedure ShowFormtexts()
  
  ;Window Title
  SetWindowTitle(WinMain,Locale::TranslatedString(85))
  
  ;Menu First
  If IsMenu(mnuMain)
    FreeMenu(mnuMain)
  EndIf
  
  ;Create New Menu
  mnuMain = CreateMenu(#PB_Any, WindowID(WinMain))
  MenuTitle(Locale::TranslatedString(52))
  MenuItem(#mnuPreferences, Locale::TranslatedString(86)) 
  MenuTitle(Locale::TranslatedString(58))
  MenuItem(#mnuShowHelp, Locale::TranslatedString(104))
  MenuBar()
  MenuItem(#mnuAbout, Locale::TranslatedString(62))
  
  ;Now The gadgets
  SetGadgetText(#txtProject,Locale::TranslatedString(87))
  GadgetToolTip(#btnProject, Locale::TranslatedString(88))
  SetGadgetText(#txtLanguage ,Locale::TranslatedString(86))
  SetGadgetText(#txtProjectFiles,Locale::TranslatedString(89))
  SetGadgetText(#btnScanFile, Locale::TranslatedString(90))
  SetGadgetText(#btnScanAll, Locale::TranslatedString(91)) 
  SetGadgetText(#txtScannedFiles,Locale::TranslatedString(92))  
  SetGadgetText(#btnUpdateFile, Locale::TranslatedString(93))
  SetGadgetText(#btnUpdateAll, Locale::TranslatedString(94)) 
  SetGadgetText(#txtUpdatedFiles,Locale::TranslatedString(95)) 
  SetGadgetText(#btnFinish, Locale::TranslatedString(96))
  SetGadgetText(#btnEditLanguage, Locale::TranslatedString(97))

EndProcedure

Procedure CheckCreatePath(Directory.s)

  BackSlashs = CountString(Directory, "\")
 
  Path$ = ""
  For i = 1 To BackSlashs + 1
    Temp$ = StringField(Directory.s, i, "\")
    If StringField(Directory.s, i+1, "\") > ""
      Path$ + Temp$ + "\"
    Else
      path$ + temp$
    EndIf
    CreateDirectory(Path$)
  Next i
  
EndProcedure

Procedure Initialise()
  
  ;Locale.pbi  For Inclusion In Selected Project
  If Not FileExists(Main::ProjectFolder + "Locale.pbi")
    CopyFile(GetCurrentDirectory() + "\Resources\Locale.pbi",Main::ProjectFolder + "Locale.pbi") 
  EndIf
  
  ;Folder To Hold Language Resource Files
  If Not FileExists(Main::ProjectFolder + "Resources\Ignore.db")
    CopyFile(GetCurrentDirectory() + "\Resources\Ignore.db",Main::ProjectFolder + "Resources\Ignore.db") 
  EndIf

  ;Folder To Hold This Projects Language File
  CheckCreatePath(Main::ProjectFolder + "Resources") 
  If Not FileExists(Main::ProjectFolder + "Resources\" + Main::ProjectTitle + ".Lng")
    CopyFile(GetCurrentDirectory() + "\Resources\App.Lng",Main::ProjectFolder + "Resources\" + Main::ProjectTitle + ".Lng") 
  EndIf
  
EndProcedure

Procedure AddToIgnore(StrToCheck.s)  
  
  Define DBIG.i
  Define Criteria.s
  
  StrToCheck = ReplaceString(StrToCheck, "'","''" )
  Criteria = "INSERT INTO Phrases(Phrase) VALUES('" + StrToCheck + "');"
  DBIG = OpenDatabase(#PB_Any,Main::ProjectFolder + "Resources\Ignore.db","","")  
  DatabaseUpdate(DBIG,Criteria)
  CloseDatabase(DBIG)
  
EndProcedure

Procedure AddToTranslate(StrToCheck.s)
    
  Define DBTL.i
  Define Criteria.s,SearchLanguage.s
  
  SearchLanguage = "LT_" + GetGadgetText(#cmbLanguage)
  
  StrToCheck = ReplaceString(StrToCheck, "'","''" )
  Criteria = "INSERT INTO Phrases(" + SearchLanguage + ") VALUES('" + StrToCheck + "');"
  DBTL = OpenDatabase(#PB_Any,Main::ProjectFolder + "Resources\" + Main::ProjectTitle  + ".Lng","","") 
  DatabaseUpdate(DBTL,Criteria)
  CloseDatabase(DBTL)
  
EndProcedure

Procedure.i Ignore(StrToCheck.s)
  
  Define Criteria.s
  
  StrToCheck = ReplaceString(StrToCheck, "'","''" )
  Criteria = "SELECT * From Phrases WHERE Phrase ='" + StrToCheck + "';"

  DBID = OpenDatabase(#PB_Any,Main::ProjectFolder + "Resources\Ignore.db","","")  
  DatabaseQuery(DBID,Criteria)
  If FirstDatabaseRow(DBID)
    FinishDatabaseQuery(DBID)   
    CloseDatabase(DBID)    
    ProcedureReturn #True
  EndIf
  FinishDatabaseQuery(DBID)
  CloseDatabase(DBID)
  ProcedureReturn #False
  
EndProcedure

Procedure.i CheckString(StrToCheck.s)
  
  Define DBID.i,RetVal.i
  Define Criteria.s,SearchLanguage.s
  
  SearchLanguage = "LT_" + GetGadgetText(#cmbLanguage)
  
  RetVal = #True
    Criteria = "SELECT * From Phrases WHERE " + SearchLanguage + " = '" + StrToCheck + "';"

    DBID = OpenDatabase(#PB_Any,Main::ProjectFolder + "Resources\" + Main::ProjectTitle  + ".Lng","","")  
 
    DatabaseQuery(DBID,Criteria)
    If FirstDatabaseRow(DBID)
      RetVal = #True
    Else
      RetVal = #False
    EndIf
    
    FinishDatabaseQuery(DBID)   
    CloseDatabase(DBID)
    
    ProcedureReturn RetVal
    
EndProcedure

Procedure.i ScanFile(FileToScan.s)
  
  Define NumOfQuotes.i,LineRead.s,LiteralString.s,ScanMessage.s
  Define CleanSweep.i = #True
  Define Cancel.i = #False
  
  ; Check File Exists
  If FileSize(FileToScan) = -1
    ProcedureReturn -1 
  EndIf
  
  ;Attempt To Read File
  LineNumber = 0
  If ReadFile(0, FileToScan)
    While Eof(0) = 0 And Cancel = #False
      LineRead = ReadString(0)
      LineNumber =   LineNumber + 1    
      
      NumOfQuotes = CountString(LineRead, #DQUOTE$)
      
      If NumOfQuotes > 0 ;There Are some Literal Strings In The Line
        For i = 2 To NumOfQuotes Step 2
          LiteralString = StringField(LineRead, i, #DQUOTE$)        
          If Len(Trim(LiteralString)) > 0 ;Ignore zero length strings
 
            If Not Ignore(Trim(LiteralString)) ;Not in ignore list
          
              If Not CheckString(Trim(LiteralString)) ;Not In Translated List
                CleanSweep = #False
                ScanMessage = Trim(LiteralString) + Chr(13) 
                ScanMessage + "In " + GetGadgetItemText(#lstProjectFiles, GetGadgetState(#lstProjectFiles)) + Chr(13)
                ScanMessage + Locale::TranslatedString(98) + Str(LineNumber) + Chr(13)
                ScanMessage + Locale::TranslatedString(99) + Chr(13)  
                ScanMessage + Locale::TranslatedString(100) + Chr(13)               
                
                Select App::Message(Locale::TranslatedString(101),ScanMessage,App::#YesNoCancel|App::#InformationIcon)        
   
                  Case App::#MsgYes
                    
                    ;Add To Translate File
                    AddToTranslate(Trim(LiteralString))
                    
                  Case App::#MsgNo
                    
                    ;Add To Ignore
                    AddToIgnore(Trim(LiteralString)) 
                    
                  Case App::#MsgCancel
                    
                    i = NumOfQuotes + 2
                    Cancel = #True
                    
                EndSelect

              EndIf
              
            EndIf 

          EndIf
          
        Next i  
        
      EndIf
      
    Wend
    
    If CleanSweep = #True And Cancel = #False
      AddGadgetItem(#lstScannedFiles,-1,GetFilePart(FileToScan))
    EndIf
    
    CloseFile(0)
    
  Else
    
    ProcedureReturn -1
    
  EndIf
  
EndProcedure

Procedure.s FetchVar(StrToCheck.s)
  
  Define DBID.i,RetVal.s
  Define iLoop.i = 0
  Define Criteria.s,SearchLanguage.s
  
  SearchLanguage = "LT_" + GetGadgetText(#cmbLanguage)
  
    Criteria = "SELECT * From Phrases ORDER BY Phrase_ID;"

    DBID = OpenDatabase(#PB_Any,Main::ProjectFolder + "Resources\" + Main::ProjectTitle  + ".Lng","","")  
 
    DatabaseQuery(DBID,Criteria)
    While NextDatabaseRow(DBID) ; Loop for each record

      If GetDatabaseString(DBID, DatabaseColumnIndex(DBID,SearchLanguage)) = Trim(StrToCheck)
        retval = "Locale::TranslatedString(" + Str(iLoop) + ")"
      Else 
        iLoop = iLoop + 1
      EndIf
    Wend
    
    FinishDatabaseQuery(DBID)   
    CloseDatabase(DBID)
    
    ProcedureReturn RetVal
    
EndProcedure

Procedure UpDateFile(FileToUpDate.s)
  
  Define NumOfQuotes.i,LineRead.s,LiteralString.s,ScanMessage.s
  Define NewFile.s,Replacement.s
  
  NewFile = GetPathPart(FileToUpDate) + "LT_" + GetFilePart(FileToUpDate)
  
  ;Attempt To Read File
  LineNumber = 0
  If ReadFile(0, FileToUpDate)
    ;Create Empty File 
    CreateFile(1, NewFile)
    While Eof(0) = 0
      LineRead = ReadString(0)
      LineNumber =   LineNumber + 1    
       
      NumOfQuotes = CountString(LineRead, #DQUOTE$)
      
      If NumOfQuotes > 0 ;There Are some Literal Strings In The Line
        For i = 2 To NumOfQuotes Step 2
          LiteralString = StringField(LineRead, i, #DQUOTE$)        
          If Len(Trim(LiteralString)) > 0 ;Ignore zero length strings
 
            If Not Ignore(Trim(LiteralString)) ;Not in ignore list
          
              ;Find The String to replace it
              LineRead =  ReplaceString(LineRead, #DQUOTE$, "||")  
              Replacement = FetchVar(Trim(LiteralString))
              LiteralString = "||" + LiteralString + "||" 
              LineRead = ReplaceString(LineRead,LiteralString,Replacement)
              LineRead = ReplaceString(LineRead,"||", #DQUOTE$)             
            EndIf 

          EndIf
          
        Next i  
        
      EndIf
      ;Write Line To New File
      WriteStringN(1, LineRead)
    Wend
    CloseFile(0)
    CloseFile(1) 
    AddGadgetItem(#lstUpdatedFiles,-1,GetFilePart(NewFile))

  Else
    
    ProcedureReturn -1
    
  EndIf
  
  
EndProcedure

Procedure LoadLanguageCombo()
  
  Define iLoop.i
  
  For iLoop = 0 To ArraySize(Locale::Available()) - 1
    AddGadgetItem(#cmbLanguage,-1,Locale::Available(iLoop))
  Next iLoop
  SetGadgetText(#cmbLanguage,Locale::AppLanguage)
  
EndProcedure

Procedure ListProjectFiles()
  
  Define Folder.s,FileName.s
  
  Folder = PathRequester(Locale::TranslatedString(105), "C:\") 
  Main::ProjectTitle = ""
  
  If Folder
    
    Main::ProjectFolder = Folder
    
    ClearGadgetItems(#lstProjectFiles)  ; Clear all the items found in the ListView
    
    If ExamineDirectory(0, Folder, "*.pb*")

          While NextDirectoryEntry(0)

            FileName = DirectoryEntryName(0)
            If DirectoryEntryType(0) = #PB_DirectoryEntry_File
              If GetExtensionPart(FileName) <> "pbp"
                ;Project Files
                AddGadgetItem(#lstProjectFiles, -1, FileName)
              Else
                ;Project Title
                Main::ProjectTitle = GetFilePart(DirectoryEntryName(0),#PB_FileSystem_NoExtension)
              EndIf
            EndIf 
          Wend
          FinishDirectory(0)
        EndIf
   EndIf
   
   If Main::ProjectTitle = ""
     Main::ProjectTitle = "Test"
   EndIf
   SetGadgetText(#strProject,Main::ProjectTitle)
   
EndProcedure

Procedure ErrorHandler()
 
  ErrorMessage$ = Locale::TranslatedString(93) + Chr(13) 
  ErrorMessage$ + Chr(13)
  ErrorMessage$ + Locale::TranslatedString(94) + ErrorMessage()      + Chr(13)
  ErrorMessage$ + Locale::TranslatedString(95) + Str(ErrorCode())    + Chr(13)  
  ErrorMessage$ + Locale::TranslatedString(96) + Str(ErrorAddress()) + Chr(13)
 
  If ErrorCode() = #PB_OnError_InvalidMemory   
    ErrorMessage$ + Locale::TranslatedString(97) + Str(ErrorTargetAddress()) + Chr(13)
  EndIf
 
  If ErrorLine() = -1
    ErrorMessage$ + Locale::TranslatedString(98) + Chr(13)
  Else
    ErrorMessage$ + Locale::TranslatedString(99) + Str(ErrorLine()) + Chr(13)
    ErrorMessage$ + Locale::TranslatedString(100) + GetFilePart(ErrorFile()) + Chr(13)
  EndIf
  
  App::Message(Locale::TranslatedString(101), ErrorMessage$,app::#OkOnly|App::#InformationIcon)

  End
 
EndProcedure

OnErrorCall(@ErrorHandler())

  WinMain = OpenWindow(#PB_Any, 0, 0, 680, 445, "Localiser", #PB_Window_SystemMenu)

  TextGadget(#txtProject, 10, 12, 80, 20, "", #PB_Text_Right)
  StringGadget(#strProject, 100, 10, 240, 20, "")
  ButtonGadget(#btnProject, 340, 10, 20, 20, "...")
  TextGadget(#txtLanguage, 380, 12, 80, 20, "", #PB_Text_Right)  
  ComboBoxGadget(#cmbLanguage, 470, 10, 160, 20) 
  TextGadget(#txtProjectFiles, 10, 40, 160, 20, "")  
  ListViewGadget(#lstProjectFiles, 10, 70, 160, 310)
  ButtonGadget(#btnScanFile, 175, 70, 80, 40, "", #PB_Button_MultiLine)
  ButtonGadget(#btnScanAll, 175, 120, 80, 40, "", #PB_Button_MultiLine)
  TextGadget(#txtScannedFiles, 260, 40, 160, 20, "")
  ListViewGadget(#lstScannedFiles, 260, 70, 160, 310)
  ButtonGadget(#btnUpdateFile, 425, 70, 80, 40, "", #PB_Button_MultiLine)
  ButtonGadget(#btnUpdateAll, 425, 120, 80, 40, "", #PB_Button_MultiLine)
  TextGadget(#txtUpdatedFiles, 510, 40, 160, 20, "") 
  ListViewGadget(#lstUpdatedFiles, 510, 70, 160, 310)
  ButtonGadget(#btnEditLanguage, 10, 390, 160, 20, "")
  ButtonGadget(#btnFinish, 600, 390, 70, 20, "")
  
  ShowFormtexts()
 
  LoadLanguageCombo()
  
  Repeat
    
    Event = WaitWindowEvent()
    

    
  Select event
      
    Case #PB_Event_CloseWindow
      If EventWindow() = Helpdlg
        HelpViewer::EventHandler(Event)
      Else
        End
      EndIf

    Case #PB_Event_Menu
      
      Select EventMenu()
          
        Case #mnuPreferences
          
          Locale::SelectLanguage()
          App::Language = Locale::AppLanguage
          App::Writepreferences("LT.ini")  
          Locale::Initialise()
          ShowFormtexts()
          
        Case #mnuShowHelp
          
          Helpdlg = HelpViewer::Open("None")
          
      EndSelect

    Case #PB_Event_Gadget
      
      Select EventGadget()
          
        Case #btnFinish
          
          End          
          
        Case  #btnProject
          ListProjectFiles()
          Initialise()
         
        Case #btnScanFile

          If GetGadgetState(#lstProjectFiles) > -1
            
            ScanFile(Main::ProjectFolder + GetGadgetItemText(#lstProjectFiles, GetGadgetState(#lstProjectFiles)))
            
          EndIf 
          
        Case #btnScanAll
          
          For iLoop = 0 To CountGadgetItems(#lstProjectFiles)
             ScanFile(Main::ProjectFolder + GetGadgetItemText(#lstProjectFiles, iLoop))
          Next iLoop
          
        Case #btnUpdateFile 
          
          If GetGadgetState(#lstScannedFiles) > -1
            
            UpdateFile(Main::ProjectFolder + GetGadgetItemText(#lstScannedFiles, GetGadgetState(#lstScannedFiles)))
            
          EndIf
          
        Case #btnUpdateAll          
          
          For iLoop = 0 To CountGadgetItems(#lstScannedFiles)
             UpdateFile(Main::ProjectFolder + GetGadgetItemText(#lstScannedFiles, iLoop))
          Next iLoop         
          
        Case #btnEditLanguage
          
          If Len(Main::ProjectTitle) > 0
            EditTranslations::Open()
          EndIf
          
      EndSelect
      
  EndSelect
  
ForEver  

; IDE Options = PureBasic 5.50 (Windows - x64)
; CursorPosition = 261
; FirstLine = 191
; Folding = rV1
; EnableXP